import React from 'react';
import './styles.css';
export interface DropdownOption {
    value: string;
    label: string;
    icon?: React.ReactElement;
}
interface DropdownProps {
    options: DropdownOption[];
    multiSelect?: boolean;
    customRenderOption?: (option: DropdownOption) => React.ReactElement;
    searchable?: boolean;
    usePortal?: boolean;
    zIndex?: number;
    onSelect: (selected: DropdownOption | DropdownOption[]) => void;
}
declare const Dropdown: ({ options, multiSelect, customRenderOption, searchable, usePortal, zIndex, onSelect, }: DropdownProps) => React.JSX.Element;
export default Dropdown;
