"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
require("./styles.css"); // Import the CSS file
var Highlight = function (_a) {
    var value = _a.value;
    return (react_1.default.createElement("span", { className: "highlight-text" }, value));
};
var HighlightText = function (_a) {
    var text = _a.text, value = _a.value, _b = _a.caseIgnored, caseIgnored = _b === void 0 ? true : _b;
    if (!value)
        return react_1.default.createElement(react_1.default.Fragment, null, text);
    var splitMatch = new RegExp(value.replace(/\\/g, '\\\\'), caseIgnored ? 'ig' : 'g');
    var values = text.match(splitMatch) || [];
    var matched = text.split(splitMatch);
    return (react_1.default.createElement("div", null, matched.map(function (item, idx) { return (react_1.default.createElement(react_1.default.Fragment, { key: idx },
        item,
        idx < values.length && react_1.default.createElement(Highlight, { value: values[idx] }))); })));
};
var Dropdown = function (_a) {
    var options = _a.options, _b = _a.multiSelect, multiSelect = _b === void 0 ? false : _b, customRenderOption = _a.customRenderOption, _c = _a.searchable, searchable = _c === void 0 ? true : _c, _d = _a.usePortal, usePortal = _d === void 0 ? false : _d, _e = _a.zIndex, zIndex = _e === void 0 ? 1000 : _e, onSelect = _a.onSelect;
    var _f = (0, react_1.useState)(false), isOpen = _f[0], setIsOpen = _f[1];
    var _g = (0, react_1.useState)(''), searchTerm = _g[0], setSearchTerm = _g[1];
    var _h = (0, react_1.useState)([]), selectedOptions = _h[0], setSelectedOptions = _h[1];
    var filteredOptions = options.filter(function (option) {
        return option.label.toLowerCase().includes(searchTerm.toLowerCase());
    });
    var handleOptionClick = function (option) {
        if (multiSelect) {
            var newSelection = selectedOptions.includes(option)
                ? selectedOptions.filter(function (o) { return o !== option; })
                : __spreadArray(__spreadArray([], selectedOptions, true), [option], false);
            setSelectedOptions(newSelection);
            onSelect(newSelection);
        }
        else {
            setSelectedOptions([option]);
            onSelect(option);
            setIsOpen(false);
        }
    };
    var handleRemoveOption = function (option) {
        var newSelection = selectedOptions.filter(function (o) { return o !== option; });
        setSelectedOptions(newSelection);
        onSelect(newSelection);
    };
    var handleClearSearch = function () {
        setSearchTerm('');
    };
    var handleDropdownClick = function () {
        setIsOpen(!isOpen);
    };
    var handleDocumentClick = function (event) {
        var target = event.target;
        var dropdownElement = document.querySelector('.dropdown-container');
        if (dropdownElement && !dropdownElement.contains(target)) {
            setIsOpen(false);
        }
    };
    // Add document click event listener when dropdown is open
    if (isOpen) {
        document.addEventListener('mousedown', handleDocumentClick);
    }
    else {
        document.removeEventListener('mousedown', handleDocumentClick);
    }
    var renderOption = function (option) { return (react_1.default.createElement("div", { key: option.value, onClick: function () { return handleOptionClick(option); }, className: "dropdown-option ".concat(selectedOptions.includes(option) ? 'selected' : '') },
        option.icon && react_1.default.createElement("div", { className: "option-icon" }, option.icon),
        react_1.default.createElement("div", { className: "keyword-wrapper" },
            react_1.default.createElement(HighlightText, { text: option.label, value: searchTerm })))); };
    var dropdownContent = (react_1.default.createElement("div", { className: "dropdown-content", style: { zIndex: zIndex } },
        searchable && (react_1.default.createElement("div", { className: "search-bar" },
            react_1.default.createElement("span", { className: "search-icon" }),
            react_1.default.createElement("input", { type: "text", value: searchTerm, onChange: function (e) { return setSearchTerm(e.target.value); }, placeholder: "", className: "search-input" }),
            searchTerm && react_1.default.createElement("button", { onClick: handleClearSearch, className: "clear-button" },
                react_1.default.createElement("span", { className: "clear-icon" })))),
        filteredOptions.length ? (filteredOptions.map(function (option) { return renderOption(option); })) : (react_1.default.createElement("div", { className: "no-options" }, "No options found"))));
    return (react_1.default.createElement("div", { className: "dropdown-container" },
        react_1.default.createElement("div", { onClick: handleDropdownClick, className: "dropdown-trigger" },
            react_1.default.createElement("div", { className: "dropdown-selected-options" }, selectedOptions.length
                ? selectedOptions.map(function (option) { return (react_1.default.createElement(SelectedOption, { key: option.value, option: option, onRemove: handleRemoveOption })); })
                : 'Select'),
            react_1.default.createElement("span", { className: "dropdown-icon" })),
        isOpen &&
            (usePortal
                ? react_dom_1.default.createPortal(dropdownContent, document.body)
                : dropdownContent)));
};
var SelectedOption = function (_a) {
    var option = _a.option, onRemove = _a.onRemove;
    return (react_1.default.createElement("span", { className: "selected-option" },
        option.label,
        react_1.default.createElement("button", { onClick: function () { return onRemove(option); }, className: "close-button" },
            react_1.default.createElement("span", { className: "close-icon" }))));
};
exports.default = Dropdown;
